import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.*;
import java.awt.font.*;

public class ControlPanel extends Container implements ActionListener, ItemListener, DLListener<TriangleChord> {
    Button B;
    Label num,avg;
    Choice inc, alpha, mode;
    int width,height;
    DrawList<TriangleChord> chords;
    ChordCanvas PC;
    TargetCanvas TC;
    HistCanvas HC;
    HashMap<String,Integer> buttonIDs = new HashMap<String,Integer>();
    static final int UNKNOWN = -1;
    static final int B_ADD = 101;
    static final int B_CLEAR = 102;
    static final int B_REDRAW = 103;
    int increment;
    double laccum;
    double limit = 1.0961444541021577481;

    public ControlPanel(ChordCanvas PC, DrawList<TriangleChord> chords)
    {
	this.width = width;
	this.height = height;
	this.chords = chords;
	this.PC = PC;

	this.chords.addListener(this);

	//	setPreferredSize(new Dimension(width,height));

	GridBagLayout gb = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	setLayout(gb);

	Label L = new Label("RandomChord by David Dumas",Label.CENTER);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	L = new Label("v2006-12-01",Label.CENTER);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);
	
	Canvas blank = new Canvas();
	blank.setPreferredSize(new Dimension(1,9));
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(blank,c);
	add(blank);
	
	L = new Label("- Control -",Label.CENTER);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	B = makeButton("Add Chords",B_ADD);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(B,c);
	add(B);

        inc = new Choice();
	inc.add("1");
	inc.add("5");
	inc.add("10");
	inc.add("50");
	inc.add("100");
	inc.add("500");
	inc.addItemListener(this);
	inc.select("50");
	increment = 50;
	c.gridwidth = 1;
	gb.setConstraints(inc,c);
	add(inc);

	L = new Label(" at a time.",Label.LEFT);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	alpha = new Choice();
	alpha.add("Nearly transparent chords");
	alpha.add("Nearly opaque chords");
	alpha.addItemListener(this);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gb.setConstraints(alpha,c);
	add(alpha);

        mode = new Choice();
	mode.add("Points, chords & geodesics");
	mode.add("Points & chords");
	mode.add("Points only");
	mode.addItemListener(this);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gb.setConstraints(mode,c);
	add(mode);

	B = makeButton("Clear",B_CLEAR);
	c.gridwidth = 1;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(B,c);
	add(B);

	B = makeButton("Redraw",B_REDRAW);
	c.gridwidth =  GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(B,c);
	add(B);

	blank = new Canvas();
	blank.setPreferredSize(new Dimension(1,12));
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(blank,c);
	add(blank);

	L = new Label("- Status -",Label.CENTER);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	num = new Label("9999",Label.RIGHT);
	c.gridwidth = 1;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(num,c);
	add(num);

	L = new Label(" chords",Label.LEFT);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	avg = new Label("1.000000",Label.RIGHT);
	c.gridwidth = 1;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(avg,c);
	add(avg);

	L = new Label(" avg len",Label.LEFT);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	L = new Label("1.09614",Label.RIGHT);
	c.gridwidth = 1;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	L = new Label(" limit",Label.LEFT);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	blank = new Canvas();
	blank.setPreferredSize(new Dimension(1,12));
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(blank,c);
	add(blank);

	L = new Label("- Average & Limit -",Label.CENTER);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	TC = new TargetCanvas(180,50,1.0f,1.2f,(float)limit,0.05f);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(TC,c);
	add(TC);

	blank = new Canvas();
	blank.setPreferredSize(new Dimension(1,8));
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(blank,c);
	add(blank);

	L = new Label("- Length Histogram -",Label.CENTER);
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(L,c);
	add(L);

	HC = new HistCanvas(180,100,4.0,0.7,15,new LengthDist());
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	gb.setConstraints(HC,c);
	add(HC);
    }

    private Button makeButton(String label, int id)
    {
	Button B;
	B = new Button(label);
	B.addActionListener(this);
	buttonIDs.put(label,id);
	return B;
    }

    private int getID(ActionEvent e)
    {
        Integer i;
	i = buttonIDs.get(e.getActionCommand());
	if (i == null)
	    return(UNKNOWN);
	else
	    return(i);
    }

    public void actionPerformed(ActionEvent e)
    {
	int i = getID(e);
	switch(i) {
	case B_ADD:
	    PC.addRandomChords(increment);
	    break;
	case B_CLEAR:
	    PC.clearChords();
	    break;
	case B_REDRAW:
	    PC.redraw();
	    break;	    
	}
    }

    public void itemStateChanged(ItemEvent e)
    {
	if (e.getStateChange() == ItemEvent.SELECTED) {
	    if (e.getItemSelectable() == inc) {
		String name = (String) e.getItem();
		try {
		    increment = Integer.parseInt(name);
		} catch (Exception ex) { }
	    } else if (e.getItemSelectable() == alpha) {
		if (alpha.getSelectedIndex() == 0) {
		    PC.setAlpha(50);
		} else {
		    PC.setAlpha(170);
		}
	    } else { // mode selector
		switch(mode.getSelectedIndex()) {
		case 0:
		    PC.setDisplayMode(ChordCanvas.MODE_BOTH);
		    PC.redraw();
		    break;
		case 1:
		    PC.setDisplayMode(ChordCanvas.MODE_CHORD);
		    PC.redraw();
		    break;
		case 2:
		    PC.setDisplayMode(ChordCanvas.MODE_POINT);
		    PC.redraw();
		    break;
		}
	    }
	}
    }

    public void DLUpdated(DLEvent<TriangleChord> e)
    {
	DrawList<TriangleChord> dl = e.getDrawList();
	//	System.out.println("Drawlist updated, length="+e.getDrawList().size());
	int size = dl.size();
	num.setText(((Integer)size).toString());
	double a = 0.0;
	HC.clear();
	if (size > 0) {
	    Iterator<TriangleChord> i = dl.iterator();
	    laccum = 0.0;
	    while (i.hasNext()) {
		double l = i.next().getLength();
		laccum += l;
		HC.add(l);
	    }
	    a = laccum / (double)size;
	    TC.setValue((float)a);
	    // The stdev of the limit distribution is 0.878856
	    // A std normal distrib has 0.95 confidence interval [-1.386,1.386]
	    //	    TC.setInterval((float)(0.878856 * 1.386 / Math.sqrt(size)));
	    TC.setInterval((float)(0.878856 * 2 / Math.sqrt(size)));
	} else {
	    TC.unSet();
	}
	HC.repaint(20);
	avg.setText(String.format("%1.5f",a));
    }
}
